program offline;
{ This will do the various sorts of computations you might want to do with
your data base but while not playing.  You might plan itineraries, identify
defensible structures, identify areas of control, spot high traffic areas,
and so on. }

{$I headers.inc}

const
  Version  = 'dos 0.88a';

var {globals}
  space     : TheVoid;
  BBSname   : string;
  quit      : boolean;
  distances : distancearray;

{$I misc.inc }
{$I GSDATA.INC }
{$I queue.inc }
{$I decount.inc }
{$I control.inc }
{$I basepath.inc }
{$I distance.inc }
{$I status.inc }
{$I textdisp.inc }
{$I hitrffic.inc }
{$I statistc.inc }

procedure menu;
begin
  writeln;
  writeln('<C>ontrolled sector status');
  writeln('<D>ead end analysis');
  writeln('<Q>uit');
  writeln('<S>tellar dispersion');
  writeln('<T>raffic area analysis');
  writeln;
end; {menu}

function choice : char;
var
  ch : char;
begin
  write('(', BBSName, ') [C, D, Q, S, T] Your choice?  ');
  readln( ch );
  choice := upcase( ch );
end;

begin
  writeln('Tradewars Offline Data Base Inquiry program: version ', version);
  writeln( author );
  writeln( source );
  writeln;
  Quit := false;
  InitSpace( Space );
  if paramcount > 0 then
    BBSName := paramstr( 1 )
  else
    BBSName := '';
  GetData( Space, BBSName );
  menu;
  repeat
    case choice of
      'C' : Control;
      'D' : DeadEndAnalysis;
      'Q' : quit := true;
      'S' : StellarDispersion;
      'T' : HighTraffic;
    else
      menu;
    end; {case}
  until quit;
end.
